module Match
  module Json
    module Schema
      module RspecMatchers
        RSpec::Matchers.define :match_json_schema do |expected|
          @error_message = ''

          match do |actual|
            begin
              JSON::Validator.validate!(expected, JSON.parse(actual.body, symbolize_names: true))
              true
            rescue JSON::Schema::ValidationError => e
              @error_message = e.message
              false
            end
          end

          failure_message do |_actual|
            @error_message
          end
        end
      end
    end
  end
end
